"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.refreshToken = exports.login = void 0;
const login_1 = require("../queries/login");
const refreshToken_1 = require("../queries/refreshToken");
const graphqlClient_1 = require("../utils/graphqlClient");
function login(email, password) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield graphqlClient_1.client().query({
            query: login_1.LoginQuery,
            variables: { email, password },
        });
        return (result.data || {}).attendeeLogin;
    });
}
exports.login = login;
function refreshToken(refreshToken) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield graphqlClient_1.client().mutate({
            mutation: refreshToken_1.RefreshTokenMutation,
            variables: { refreshToken },
        });
        return (_a = result.data) === null || _a === void 0 ? void 0 : _a.refreshAccessToken;
    });
}
exports.refreshToken = refreshToken;
