"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeText = exports.getTextFrames = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const Cursor_1 = require("../common/Cursor");
const Animation_1 = require("./Animation");
const BlinkingCursor_1 = require("./BlinkingCursor");
function getTextFrames(text) {
    const frames = [];
    for (let currentLength = 0; currentLength <= text.length; currentLength++) {
        frames.push(text.substr(0, currentLength));
    }
    return frames;
}
exports.getTextFrames = getTextFrames;
exports.TypeText = (_a) => {
    var { text, cursorColor = undefined, showCursor = undefined, TextComponent = ink_1.Text, intervalSpeed = 50, onDone = undefined } = _a, props = __rest(_a, ["text", "cursorColor", "showCursor", "TextComponent", "intervalSpeed", "onDone"]);
    if (typeof text !== 'string') {
        throw new Error('only excepts a string as text');
    }
    const [animationDone, setAnimationDone] = react_1.useState(false);
    const frames = react_1.useMemo(() => getTextFrames(text), [text]);
    const animationCallback = react_1.useCallback(() => {
        setAnimationDone(true);
        if (typeof onDone === 'function') {
            onDone();
        }
    }, [onDone]);
    let cursor = showCursor ? (react_1.default.createElement(Cursor_1.Cursor, { color: cursorColor, active: !animationDone })) : ('');
    if (showCursor === 'blinking' && animationDone) {
        cursor = react_1.default.createElement(BlinkingCursor_1.BlinkingCursor, { color: cursorColor });
    }
    return (react_1.default.createElement(Animation_1.Animation, Object.assign({}, props, { frames: frames, onDone: animationCallback, intervalSpeed: intervalSpeed }), (frame) => (react_1.default.createElement(TextComponent, null,
        frame,
        cursor))));
};
