"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatInput = void 0;
const ink_1 = require("ink");
const ink_text_input_1 = __importDefault(require("ink-text-input"));
const react_1 = __importStar(require("react"));
const Button_1 = require("../common/Button");
function ChatInput({ prompt, onSend, placeholder = undefined, clearOnSend = true, active = true, }) {
    const [content, setContent] = react_1.useState('');
    const onAction = react_1.useCallback(() => {
        if (!active) {
            return;
        }
        const trimmedContent = content.trim();
        if (trimmedContent) {
            if (typeof onSend === 'function') {
                onSend(trimmedContent);
            }
            if (clearOnSend) {
                setContent('');
            }
        }
    }, [active, content]);
    return (react_1.default.createElement(ink_1.Box, { width: "100%", borderStyle: "single", paddingLeft: 1, paddingRight: 1, height: 3, minHeight: 3 },
        react_1.default.createElement(ink_1.Box, { marginRight: 1 },
            react_1.default.createElement(ink_1.Text, null, prompt)),
        react_1.default.createElement(ink_1.Box, { flexGrow: 1 },
            react_1.default.createElement(ink_text_input_1.default, { focus: active, placeholder: placeholder, onChange: setContent, value: content })),
        react_1.default.createElement(ink_1.Box, null,
            react_1.default.createElement(Button_1.Button, { autoFocus: true, onAction: onAction, dimColor: !active }, "Send Request"))));
}
exports.ChatInput = ChatInput;
