"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatWindow = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const ChatInput_1 = require("./ChatInput");
const ChatMessages_1 = require("./ChatMessages");
function ChatWindow({ messages, footer, prompt, onSend, placeholder, active, }) {
    return (react_1.default.createElement(ink_1.Box, { width: "100%", flexGrow: 1, flexDirection: "column" },
        react_1.default.createElement(ChatMessages_1.ChatMessages, { messages: messages }),
        react_1.default.createElement(ChatInput_1.ChatInput, { placeholder: placeholder, prompt: prompt, onSend: onSend, active: active }),
        footer ? footer : null));
}
exports.ChatWindow = ChatWindow;
