"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Divider = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const useResize_1 = require("../../hooks/useResize");
function computeString(text, width, symbol) {
    if (symbol.length > 1) {
        throw new Error('Symbol can only be one character');
    }
    const paddingTotal = width - text.length - 2;
    const paddingSide = Math.floor(paddingTotal / 2);
    return `${symbol.repeat(paddingSide)} ${text} ${symbol.repeat(paddingSide)}`;
}
exports.Divider = ({ title, symbol = '-' }) => {
    const [text, setText] = react_1.useState(title);
    const { width, ref } = useResize_1.useResponsiveMeasureElement();
    react_1.useEffect(() => {
        if (!isNaN(width) && width > 0) {
            setText(computeString(title, width, symbol));
        }
    }, [title, width]);
    return (react_1.default.createElement(ink_1.Box, { ref: ref, width: "100%" },
        react_1.default.createElement(ink_1.Text, null, text)));
};
