"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Headline = void 0;
const cfonts_1 = __importDefault(require("cfonts"));
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const SmallHeadline_1 = require("./SmallHeadline");
function renderBigHeadline(text, size) {
    return cfonts_1.default.render(text, {
        maxLength: size.width,
    }, false, 2, {
        width: size.width,
        height: size.height,
    }).string;
}
function Headline({ text, shouldRenderLargeHeadline = true, windowWidth, windowHeight, }) {
    const size = windowWidth && windowHeight
        ? { width: windowWidth, height: windowHeight }
        : undefined;
    const headline = react_1.useMemo(() => renderBigHeadline(text, size), [
        text,
        windowWidth,
        windowHeight,
    ]);
    if (!shouldRenderLargeHeadline) {
        return react_1.default.createElement(SmallHeadline_1.SmallHeadline, { text: text });
    }
    return react_1.default.createElement(ink_1.Text, null, headline);
}
exports.Headline = Headline;
