"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadingIndicator = void 0;
const ink_1 = require("ink");
const ink_spinner_1 = __importDefault(require("ink-spinner"));
const react_1 = __importDefault(require("react"));
const useAnimation_1 = require("../../hooks/useAnimation");
const useTerminalInfo_1 = require("../../hooks/useTerminalInfo");
function LoadingIndicator({ text }) {
    const { shouldAnimate } = useAnimation_1.useAnimation();
    const { isWindows } = useTerminalInfo_1.useTerminalInfo();
    const spinnerType = isWindows ? 'line' : 'dots';
    return (react_1.default.createElement(ink_1.Text, null,
        react_1.default.createElement(ink_1.Text, { color: "green" }, shouldAnimate && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(ink_spinner_1.default, { type: spinnerType }),
            ' '))),
        text));
}
exports.LoadingIndicator = LoadingIndicator;
