"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProgrammingLanguageTag = exports.ColorCombinations = void 0;
const react_1 = __importDefault(require("react"));
const Inverse_1 = require("./Inverse");
exports.ColorCombinations = {
    JavaScript: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'black',
            backgroundColor: 'yellowBright',
        },
    },
    'C#': {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'green',
        },
    },
    Ruby: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'redBright',
        },
    },
    Python: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'yellowBright',
            backgroundColor: 'blue',
        },
    },
    Swift: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'black',
            backgroundColor: 'whiteBright',
        },
    },
    Java: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'red',
            backgroundColor: 'whiteBright',
        },
    },
    PHP: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'magenta',
        },
    },
    Android: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'green',
        },
    },
    'C++': {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'green',
        },
    },
    '.NET': {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'magenta',
        },
    },
    TypeScript: {
        default: {
            color: 'whiteBright',
            backgroundColor: 'red',
        },
        active: {
            color: 'whiteBright',
            backgroundColor: 'blue',
        },
    },
    Default: {
        default: {},
        active: {},
    },
};
function ProgrammingLanguageTag({ language, active = false, }) {
    const colorScheme = exports.ColorCombinations[language];
    return (react_1.default.createElement(Inverse_1.Inverse, Object.assign({}, colorScheme[active ? 'active' : 'default']), language));
}
exports.ProgrammingLanguageTag = ProgrammingLanguageTag;
