"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DemoOptions = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const demoEntryMachine_1 = require("../../machines/demoEntryMachine");
const Selectable_1 = require("../common/Selectable");
const VerticalSpacer_1 = require("../common/VerticalSpacer");
function DemoOptions({ hasQuickDeploy, selectedOption, hasDownloadOption, hasViewCodeOption, }) {
    return (react_1.default.createElement(ink_1.Box, { justifyContent: "flex-start", marginTop: 1 },
        react_1.default.createElement(ink_1.Box, null,
            react_1.default.createElement(Selectable_1.Selectable, { active: selectedOption === demoEntryMachine_1.DemoEntryOptions.LEARN_MORE }, "Learn More")),
        hasViewCodeOption && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(VerticalSpacer_1.VerticalSpacer, null),
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(Selectable_1.Selectable, { active: selectedOption === demoEntryMachine_1.DemoEntryOptions.VIEW_CODE }, "View Code")))),
        hasDownloadOption && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(VerticalSpacer_1.VerticalSpacer, null),
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(Selectable_1.Selectable, { active: selectedOption === demoEntryMachine_1.DemoEntryOptions.DOWNLOAD }, "Download & Setup")))),
        hasQuickDeploy && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(VerticalSpacer_1.VerticalSpacer, null),
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(Selectable_1.Selectable, { active: selectedOption === demoEntryMachine_1.DemoEntryOptions.QUICK_DEPLOY }, "Quick Deploy"))))));
}
exports.DemoOptions = DemoOptions;
