"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InteractiveDemoEntry = void 0;
const react_1 = require("@xstate/react");
const ink_1 = require("ink");
const react_2 = __importStar(require("react"));
const useTerminalInfo_1 = require("../../hooks/useTerminalInfo");
const demoEntryMachine_1 = require("../../machines/demoEntryMachine");
const DemoEntryBox_1 = require("./DemoEntryBox");
const DemoOptions_1 = require("./DemoOptions");
function InteractiveDemoEntry(_a) {
    var { demo, initialActiveLanguageIdx = 0, active = true, onSelect } = _a, props = __rest(_a, ["demo", "initialActiveLanguageIdx", "active", "onSelect"]);
    const { hasGit } = useTerminalInfo_1.useTerminalInfo();
    const [state, dispatch] = react_1.useMachine(demoEntryMachine_1.demoEntryStateMachine, {
        context: {
            demo,
            hasGit,
            activeLanguageIdx: initialActiveLanguageIdx,
        },
    });
    react_2.useEffect(() => {
        var _a, _b;
        if (((_b = (_a = state.context) === null || _a === void 0 ? void 0 : _a.demo) === null || _b === void 0 ? void 0 : _b.key) !== demo.key) {
            dispatch({ type: 'RESET', data: demo });
        }
    }, [demo]);
    ink_1.useInput((input, key) => {
        if (key.tab) {
            if (key.shift) {
                dispatch('PREV_LANGUAGE');
                return;
            }
            dispatch('NEXT_LANGUAGE');
            return;
        }
        if (key.leftArrow) {
            dispatch('PREV_OPTION');
            return;
        }
        if (key.rightArrow) {
            dispatch('NEXT_OPTION');
            return;
        }
        if (key.return) {
            if (typeof onSelect === 'function') {
                onSelect(state.value.toString(), state.context.activeLanguageIdx);
            }
        }
    }, {
        isActive: active,
    });
    return (react_2.default.createElement(DemoEntryBox_1.DemoEntryBox, Object.assign({ demo: demo, activeLanguageIdx: state.context.activeLanguageIdx }, props),
        react_2.default.createElement(DemoOptions_1.DemoOptions, { hasQuickDeploy: demoEntryMachine_1.hasQuickDeploy(state.context), hasDownloadOption: demoEntryMachine_1.hasDownload(state.context), hasViewCodeOption: demoEntryMachine_1.hasViewCode(state.context), selectedOption: state.value.toString() })));
}
exports.InteractiveDemoEntry = InteractiveDemoEntry;
