"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ITermWarning = void 0;
const figures_1 = __importDefault(require("figures"));
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useTerminalInfo_1 = require("../../hooks/useTerminalInfo");
const Bold_1 = require("../common/Bold");
function ITermWarning() {
    const { isITerm, isTmux } = useTerminalInfo_1.useTerminalInfo();
    if (!isITerm || (isITerm && isTmux)) {
        return null;
    }
    return (react_1.default.createElement(ink_1.Box, { width: "100%", justifyContent: "center", borderStyle: "double" },
        react_1.default.createElement(ink_1.Box, { flexDirection: "column" },
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(ink_1.Text, null,
                    react_1.default.createElement(Bold_1.Bold, { color: "cyan" },
                        figures_1.default.info,
                        " Important"))),
            react_1.default.createElement(ink_1.Box, null,
                react_1.default.createElement(ink_1.Text, { wrap: "wrap" }, "You may experience flickering and other rendering issues when using this terminal. We will limit animations to improve your experience, but you may wish to use another app such as your system Terminal or Hyper. Alternatively, try using tmux.")),
            react_1.default.createElement(ink_1.Text, null, "More Info: https://github.com/vadimdemedes/ink/issues/359"))));
}
exports.ITermWarning = ITermWarning;
