"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckUpdateAvailable = exports.UpdateNotice = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useVersionCheck_1 = require("../../hooks/useVersionCheck");
const Code_1 = require("../common/Code");
const Info_1 = require("../common/Info");
function UpdateNotice() {
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column" },
        react_1.default.createElement(Info_1.Info, { text: "New Version" }),
        react_1.default.createElement(ink_1.Text, null,
            "Please exit, run",
            ' ',
            react_1.default.createElement(Code_1.Code, null, 'twilio plugins:remove @twilio-labs/plugin-signal2020 && twilio plugins:install @twilio-labs/plugin-signal2020@latest'),
            ' ',
            "and restart Developer Mode with ",
            react_1.default.createElement(Code_1.Code, null, "twilio signal2020"),
            ".")));
}
exports.UpdateNotice = UpdateNotice;
function CheckUpdateAvailable() {
    const versionInfo = useVersionCheck_1.useVersionCheck();
    return versionInfo.updateAvailable ? react_1.default.createElement(UpdateNotice, null) : null;
}
exports.CheckUpdateAvailable = CheckUpdateAvailable;
