"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfirmInput = exports.textToBoolean = void 0;
const ink_text_input_1 = __importDefault(require("ink-text-input"));
const react_1 = __importStar(require("react"));
function textToBoolean(text, defaultValue) {
    const normalizedText = text.toLowerCase().trim();
    if (normalizedText === '') {
        return defaultValue;
    }
    if (normalizedText === 'y' ||
        normalizedText === 'yes' ||
        normalizedText === 'true') {
        return true;
    }
    if (normalizedText === 'n' ||
        normalizedText === 'no' ||
        normalizedText === 'false') {
        return false;
    }
    return null;
}
exports.textToBoolean = textToBoolean;
exports.ConfirmInput = (_a) => {
    var { name, onSubmit, defaultValue = false, onInvalid } = _a, props = __rest(_a, ["name", "onSubmit", "defaultValue", "onInvalid"]);
    const [value, setValue] = react_1.useState('');
    const wrappedOnSubmit = react_1.useCallback((val) => {
        const booleanVal = textToBoolean(val, defaultValue);
        if (typeof booleanVal !== 'boolean') {
            if (typeof onInvalid === 'function') {
                onInvalid(val);
            }
            return;
        }
        if (val.trim().length === 0) {
            setValue(defaultValue ? 'Y' : 'N');
        }
        if (typeof onSubmit === 'function') {
            onSubmit({
                [name]: booleanVal,
            });
        }
    }, [name, onSubmit]);
    return (react_1.default.createElement(ink_text_input_1.default, Object.assign({ value: value, onChange: setValue, onSubmit: wrappedOnSubmit }, props)));
};
