"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Form = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const ScrollableItemList_1 = require("../scrollable/ScrollableItemList");
const Input_1 = require("./Input");
function Form({ questions, onUpdate = undefined, onSubmit, scrollable = false, showScrollIndicators = false, }) {
    const reducer = (state, action) => {
        if (action.type === 'new-entry') {
            const newState = Object.assign(Object.assign({}, state), { answers: Object.assign(Object.assign({}, state.answers), action.data), activeIndex: state.activeIndex + 1 });
            const hasAnsweredAllQuestions = questions.every((q) => typeof newState.answers[q.name] !== 'undefined');
            const nameOfAnsweredQuestion = Object.keys(action.data)[0];
            const answeredQuestion = questions.find((q) => q.name === nameOfAnsweredQuestion);
            const hasAnsweredQuestionWithEarlyExit = typeof (answeredQuestion === null || answeredQuestion === void 0 ? void 0 : answeredQuestion.earlyExitIfValue) === 'function' &&
                answeredQuestion.earlyExitIfValue() ===
                    action.data[nameOfAnsweredQuestion];
            if ((hasAnsweredAllQuestions || hasAnsweredQuestionWithEarlyExit) &&
                typeof onSubmit === 'function') {
                onSubmit(newState.answers);
            }
            else if (typeof onUpdate === 'function') {
                onUpdate(action.data);
            }
            return newState;
        }
        return state;
    };
    const [state, dispatch] = react_1.useReducer(reducer, {
        activeIndex: 0,
        answers: {},
    });
    let Wrapper = ink_1.Box;
    let additionalProps = {};
    if (scrollable) {
        Wrapper = ScrollableItemList_1.ScrollableItemList;
        additionalProps = {
            activeIdx: state.activeIndex,
            showScrollIndicator: showScrollIndicators,
            rowsPerLine: 2,
            borderStyle: null,
            moreAboveText: `${state.activeIndex} questions done`,
            moreBelowText: `${questions.length - state.activeIndex} questions to do`,
        };
    }
    return (react_1.default.createElement(Wrapper, Object.assign({ flexDirection: "column" }, additionalProps), questions.map((q, idx) => (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Input_1.Input, Object.assign({}, q, { key: q.name, onSubmit: (partialAnswer) => 
            // @ts-ignore
            dispatch({ type: 'new-entry', data: partialAnswer }), active: idx === state.activeIndex, done: typeof state.answers[q.name] !== 'undefined' })))))));
}
exports.Form = Form;
