"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Avatar = void 0;
const react_1 = __importDefault(require("react"));
const useImage_1 = require("../../hooks/useImage");
const useResize_1 = require("../../hooks/useResize");
const Image_1 = require("./Image");
function Avatar({ imageBuffer }) {
    const { width: availableWidth, height: availableHeight, ref, } = useResize_1.useResponsiveMeasureElement();
    const imageWidth = isNaN(availableWidth) ? 34 : availableWidth - 4;
    const imageString = useImage_1.useImage(imageBuffer, imageWidth);
    return react_1.default.createElement(Image_1.Image, { ref: ref, imageString: imageString, height: availableHeight });
}
exports.Avatar = Avatar;
