"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DownloadProjectQuestions = exports.getDownloadQuestions = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const Form_1 = require("../../form/Form");
function getDownloadQuestions(context) {
    const questions = [
        {
            type: 'confirm',
            name: 'shouldDownload',
            message: `Do you want to download the project?`,
            details: `Download from ${context.repoUrl} into ${context.directory}?`,
            earlyExitIfValue: () => false,
        },
    ];
    if (!context.isEmptyDirectory) {
        questions.push({
            type: 'confirm',
            name: 'force',
            message: `Do you want to continue?`,
            details: 'The folder is not empty. Do you want to proceed anyways? This will override the project.',
        });
    }
    return questions;
}
exports.getDownloadQuestions = getDownloadQuestions;
function DownloadProjectQuestions({ dispatch, context, }) {
    const questions = react_1.useMemo(() => getDownloadQuestions(context), [context]);
    const onSubmit = react_1.useCallback((data) => {
        if (!data.shouldDownload) {
            dispatch({ type: 'DENY' });
        }
        else {
            if (data.force || typeof data.force === 'undefined') {
                dispatch({ type: 'CONFIRM' });
            }
            else {
                dispatch({ type: 'DENY' });
            }
        }
    }, []);
    return (react_1.default.createElement(ink_1.Box, { height: 2, minHeight: 2, flexGrow: 1, flexShrink: 0 },
        react_1.default.createElement(Form_1.Form, { questions: questions, onSubmit: onSubmit, scrollable: true })));
}
exports.DownloadProjectQuestions = DownloadProjectQuestions;
