"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetupProjectQuestions = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const installer_1 = require("../../../utils/installer");
const Form_1 = require("../../form/Form");
function SetupProjectQuestions({ directory, dispatch, defaultValues, }) {
    const [parsedResult, setParsedResult] = react_1.useState(undefined);
    react_1.useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            const parsedEnvResult = yield installer_1.getEnvSetupQuestions(directory, defaultValues);
            if (parsedEnvResult) {
                parsedEnvResult.questions = [
                    {
                        type: 'confirm',
                        name: 'setup',
                        message: `Do you want to setup project?`,
                        details: `We'll ask you for a couple of configuration values. Alternatively you can manually follow the instructions in the project.`,
                        earlyExitIfValue: () => false,
                    },
                    ...parsedEnvResult.questions,
                ];
            }
            setParsedResult(parsedEnvResult);
        }))();
    }, []);
    const onSubmit = react_1.useCallback((data) => {
        if (!data.setup) {
            dispatch({ type: 'DENY' });
        }
        else {
            dispatch({
                type: 'CONFIRM_CONFIGURING',
                data: Object.assign(Object.assign({}, parsedResult), { answers: data }),
            });
        }
    }, [parsedResult]);
    react_1.useEffect(() => {
        if (parsedResult === null) {
            dispatch({ type: 'DENY' });
        }
    }, [parsedResult]);
    if (!parsedResult) {
        return react_1.default.createElement(ink_1.Text, null, "Loading configuration values...");
    }
    return (react_1.default.createElement(ink_1.Box, { minHeight: 6, flexGrow: 1, flexShrink: 0 },
        react_1.default.createElement(Form_1.Form, { questions: parsedResult === null || parsedResult === void 0 ? void 0 : parsedResult.questions, onSubmit: onSubmit, scrollable: true, showScrollIndicators: true })));
}
exports.SetupProjectQuestions = SetupProjectQuestions;
