"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActiveKeynoteView = void 0;
const ink_1 = require("ink");
const ink_link_1 = __importDefault(require("ink-link"));
const react_1 = __importDefault(require("react"));
const useResize_1 = require("../../hooks/useResize");
const config_1 = __importDefault(require("../../utils/config"));
const dateHelpers_1 = require("../../utils/dateHelpers");
const Bold_1 = require("../common/Bold");
const Key_1 = require("../common/Key");
const InspectorResourceView_1 = require("./InspectorResourceView");
const VttViewer_1 = require("./VttViewer");
function ActiveKeynoteView({ time, vttString, inspectorData, }) {
    const { height } = useResize_1.useResponsiveWindowSize();
    const slim = (height || 0) < 26;
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column", flexGrow: 1, flexShrink: 1, padding: 1 },
        react_1.default.createElement(ink_1.Text, null,
            react_1.default.createElement(Bold_1.Bold, null, "Live Closed Captioning."),
            " Time ",
            dateHelpers_1.timeToText(time)),
        react_1.default.createElement(VttViewer_1.VttViewer, { vttString: vttString, time: time, slim: slim }),
        react_1.default.createElement(InspectorResourceView_1.InspectorResourceView, { inspectorData: inspectorData, time: time, slim: slim }),
        react_1.default.createElement(ink_1.Spacer, null),
        react_1.default.createElement(ink_1.Box, { alignItems: "center", flexDirection: "column" },
            react_1.default.createElement(Bold_1.Bold, null, "The contents of this screen update live as you are watching the keynote in your browser."),
            react_1.default.createElement(ink_1.Text, null,
                "All demos can also be found in the demos section. Press ",
                react_1.default.createElement(Key_1.Key, null, "d"),
                ' ',
                "to enter the demo section."),
            react_1.default.createElement(ink_1.Text, null,
                "To watch the video footage.",
                ' ',
                react_1.default.createElement(ink_link_1.default, { url: config_1.default.signalWebsite },
                    react_1.default.createElement(ink_1.Text, null, "Head over to the SIGNAL website."))))));
}
exports.ActiveKeynoteView = ActiveKeynoteView;
