"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InactiveKeynotePane = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const user_1 = require("../../context/user");
const openLink_1 = require("../../utils/openLink");
const Button_1 = require("../common/Button");
const Key_1 = require("../common/Key");
const PaneContent_1 = require("../panes/PaneContent");
function InactiveKeynotePane({ keynoteSessionIds, }) {
    const user = user_1.useUser();
    const openKeynote = react_1.useCallback(() => {
        const sessionIdx = user.region === 'APJ' ? 1 : user.region === 'EMEA' ? 2 : 0;
        openLink_1.openSessionUrl(keynoteSessionIds[sessionIdx]);
    }, [keynoteSessionIds, user.region]);
    return (react_1.default.createElement(PaneContent_1.PaneContent, { marginTop: 1 },
        react_1.default.createElement(ink_1.Text, null,
            "For this section to activate you must be watching the keynote in your browser.",
            react_1.default.createElement(ink_1.Newline, { count: 2 }),
            "Hit ",
            react_1.default.createElement(Key_1.Key, null, "Return"),
            "/",
            react_1.default.createElement(Key_1.Key, null, "Enter"),
            " to open the keynote to see when it starts.",
            react_1.default.createElement(ink_1.Newline, { count: 2 }),
            react_1.default.createElement(Button_1.Button, { onAction: openKeynote, focusable: true, autoFocus: true }, "Open Keynote"))));
}
exports.InactiveKeynotePane = InactiveKeynotePane;
