"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VttViewer = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useVtt_1 = require("../../hooks/useVtt");
function VttLine({ text }) {
    return react_1.default.createElement(ink_1.Text, null, text);
}
function VttViewer({ vttString, time, slim = false }) {
    const vtt = useVtt_1.useVtt(vttString);
    const entries = vtt.cues.filter((c) => c.start <= time && c.end >= time);
    return (react_1.default.createElement(ink_1.Box, { alignItems: "center", borderStyle: "bold", borderColor: "red", flexDirection: "column", paddingX: 1, paddingY: slim ? 0 : 1, minHeight: slim ? 4 : 6 }, entries.map((e) => (react_1.default.createElement(VttLine, Object.assign({}, e))))));
}
exports.VttViewer = VttViewer;
