"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderIfWindowSize = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useResize_1 = require("../../hooks/useResize");
function RenderIfWindowSize(_a) {
    var { children, fallback = null } = _a, breakpoint = __rest(_a, ["children", "fallback"]);
    const { width: totalWidth, height: totalHeight } = useResize_1.useResponsiveWindowSize();
    const shouldRender = useResize_1.shouldRenderBasedOnBreakpoint(breakpoint, totalWidth || 0, totalHeight || 0);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ink_1.Box, { display: shouldRender ? 'flex' : 'none' }, children),
        !shouldRender && fallback ? fallback : null));
}
exports.RenderIfWindowSize = RenderIfWindowSize;
