"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheatModePane = void 0;
const react_1 = require("@xstate/react");
const clipboardy_1 = __importDefault(require("clipboardy"));
const got_1 = __importDefault(require("got"));
const ink_1 = require("ink");
const react_2 = __importStar(require("react"));
const uuid_1 = require("uuid");
const xstate_1 = require("xstate");
const mode_1 = require("../../context/mode");
const user_1 = require("../../context/user");
const cheatModeMachine_1 = require("../../machines/cheatModeMachine");
const modeMachine_1 = require("../../machines/modeMachine");
const breakpoints_1 = require("../../utils/breakpoints");
const cheatModeApi_1 = require("../../utils/cheatModeApi");
const config_1 = __importDefault(require("../../utils/config"));
const deployTwimlApp_1 = require("../../utils/deployTwimlApp");
const logger_1 = __importDefault(require("../../utils/logger"));
const ChatWindow_1 = require("../chat/ChatWindow");
const Bold_1 = require("../common/Bold");
const Button_1 = require("../common/Button");
const Key_1 = require("../common/Key");
const LoadingIndicator_1 = require("../common/LoadingIndicator");
const VerticalSpacer_1 = require("../common/VerticalSpacer");
const Pane_1 = require("./Pane");
const PaneContent_1 = require("./PaneContent");
const logger = logger_1.default.child({ module: 'CheatModePane' });
function createMessageEntry(msg) {
    return Object.assign(Object.assign({}, msg), { id: uuid_1.v4() });
}
function deployApp(context, event) {
    if (!context.latestTwiml || !context.username || !context.password) {
        return;
    }
    return deployTwimlApp_1.deployTwimlApp(context.latestTwiml, context.username, context.password, (msg) => {
        event.dispatch({ type: cheatModeMachine_1.CheatModeEvents.UPDATE, data: msg });
    });
}
function requestTwiml(context) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!context.currentRequest) {
            const error = new Error('invalid state transition');
            logger.error({ msg: 'invalid state transition', context, error });
            throw error;
        }
        return cheatModeApi_1.cheatModeApiQuery(context.currentRequest).then((resp) => {
            return resp.twiml;
        });
    });
}
function contextHasValidTwiml(context) {
    return (typeof context.latestTwiml === 'string' && context.latestTwiml.length > 0);
}
function canDeploy(context) {
    return (!!context.username && !!context.password && contextHasValidTwiml(context));
}
const addRequestMessage = xstate_1.assign({
    currentRequest: (_, event) => event.data,
    messages: (context, event) => {
        return [
            ...context.messages,
            createMessageEntry({ author: 'You', content: event.data }),
            createMessageEntry({
                author: null,
                content: react_2.default.createElement(LoadingIndicator_1.LoadingIndicator, { text: 'waiting for response' }),
            }),
        ];
    },
});
const addErrorMessage = xstate_1.assign({
    errors: (context, event) => [...context.errors, event.data],
    messages: (context) => [
        ...context.messages,
        createMessageEntry({
            author: 'Error',
            content: 'Oh no something went wrong. Please try again later.',
        }),
    ],
});
const addTwimlResult = xstate_1.assign({
    messages: (context, event) => {
        const newContentMessage = createMessageEntry({
            author: 'The Cloud',
            content: `Here's your app:`,
        });
        const twimlMessages = event.data.twiml.split('\r\n').map((line) => {
            const fixedSpacingLine = line.split('\t').join('  ');
            return createMessageEntry({
                author: null,
                content: react_2.default.createElement(ink_1.Text, { color: "redBright" }, fixedSpacingLine),
            });
        });
        return [
            ...context.messages.slice(0, context.messages.length - 1),
            newContentMessage,
            ...twimlMessages,
        ];
    },
    latestTwiml: (_, event) => event.data.twiml,
});
const addDeployResult = xstate_1.assign({
    latestDeploymentInfo: (_, event) => event.data,
    messages: (context, event) => [
        ...context.messages,
        createMessageEntry({
            author: 'Twilio',
            content: `Deployed at https://${event.data.domain}/`,
        }),
    ],
});
const handleUpdateMessage = xstate_1.assign({
    messages: (context, event) => [
        ...context.messages,
        createMessageEntry({
            author: 'Twilio',
            content: event.data,
        }),
    ],
});
function isCheatModeActive() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const resp = yield got_1.default(`${config_1.default.cheatModeApi}/mode`, {
                responseType: 'json',
            });
            const body = resp.body;
            return body.enabled;
        }
        catch (err) {
            return false;
        }
    });
}
const fallbackCheatmode = (react_2.default.createElement(ink_1.Text, null,
    "Your terminal is too small to support the best experience for cheat mode. Try hiding the sidebar using ",
    react_2.default.createElement(Key_1.Key, null, "Ctrl"),
    "+",
    react_2.default.createElement(Key_1.Key, null, "b"),
    " or increase the size of your terminal until this message disappears."));
exports.CheatModePane = () => {
    const { dispatch: modeDispatch } = mode_1.useMode();
    const user = user_1.useUser();
    const [state, dispatch] = react_1.useMachine(cheatModeMachine_1.cheatModeMachine, {
        context: {
            latestDeploymentInfo: undefined,
            currentRequest: undefined,
            latestTwiml: undefined,
            messages: [],
            errors: [],
            username: user.twilioUsername,
            password: user.twilioPassword,
        },
        services: {
            fetchResult: requestTwiml,
            deployResult: deployApp,
        },
        actions: {
            addRequestMessage: addRequestMessage,
            addTwimlResult: addTwimlResult,
            addErrorMessage: addErrorMessage,
            addDeployResult: addDeployResult,
            handleUpdateMessage: handleUpdateMessage,
        },
        guards: {
            canDeploy: canDeploy,
        },
    });
    const deploy = react_2.useCallback(() => {
        dispatch({ type: 'DEPLOY', dispatch });
    }, [user, dispatch]);
    const back = react_2.useCallback(() => {
        modeDispatch({ type: modeMachine_1.ModeEvents.exitCheatMode });
    }, []);
    const copy = react_2.useCallback(() => {
        const twimlContent = state.context.latestTwiml;
        if (twimlContent) {
            clipboardy_1.default.writeSync(twimlContent);
        }
    }, [state.context]);
    const onSend = (text) => {
        dispatch({
            type: cheatModeMachine_1.CheatModeEvents.REQUEST,
            data: text,
        });
    };
    react_2.useEffect(() => {
        isCheatModeActive().then((active) => {
            if (active) {
                dispatch(cheatModeMachine_1.CheatModeEvents.ACTIVATE);
            }
            else {
                modeDispatch({ type: modeMachine_1.ModeEvents.enableInput });
                dispatch(cheatModeMachine_1.CheatModeEvents.DEACTIVATE);
            }
        });
    }, []);
    ink_1.useInput((input, key) => {
        if (key.ctrl && input.toLowerCase() === 'b') {
            modeDispatch({ type: modeMachine_1.ModeEvents.toggleSideBar });
        }
        if (key.ctrl && input.toLowerCase() === 'd') {
            dispatch(cheatModeMachine_1.CheatModeEvents.DEACTIVATE);
            modeDispatch({ type: modeMachine_1.ModeEvents.exitCheatMode });
        }
    });
    const hasTwimlResult = !!state.context.latestTwiml;
    const canDeployResult = canDeploy(state.context) && state.matches('idle');
    const Footer = (react_2.default.createElement(ink_1.Box, { padding: 1, paddingRight: 0, paddingLeft: 0 },
        react_2.default.createElement(Button_1.Button, { onAction: deploy, focusable: canDeployResult, dimColor: !canDeployResult }, "Deploy App"),
        react_2.default.createElement(VerticalSpacer_1.VerticalSpacer, null),
        react_2.default.createElement(Button_1.Button, { onAction: copy, focusable: hasTwimlResult, dimColor: !hasTwimlResult }, "Copy TwiML"),
        react_2.default.createElement(VerticalSpacer_1.VerticalSpacer, null),
        react_2.default.createElement(Button_1.Button, { onAction: back }, "Back To Welcome")));
    const activeContent = (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(ink_1.Box, { flexDirection: "column", paddingLeft: 2, paddingRight: 2 },
            react_2.default.createElement(Bold_1.Bold, null, "Welcome to the hidden world of the SIGNAL Developer Mode"),
            react_2.default.createElement(ink_1.Text, null, "In this section you'll be able to harness the power of the cloud to generate apps with just your thoughts (and writing them down)."),
            react_2.default.createElement(ink_1.Text, null, "Tell us what you want to build and we'll send you the code. Afterwards you can deploy the app directly to your Twilio account."),
            react_2.default.createElement(ink_1.Text, null,
                "Use the ",
                react_2.default.createElement(Key_1.Key, null, "Tab"),
                " and ",
                react_2.default.createElement(Key_1.Key, null, "Return"),
                "/",
                react_2.default.createElement(Key_1.Key, null, "Enter"),
                " keys to navigate between the functionality in this realm.")),
        react_2.default.createElement(ChatWindow_1.ChatWindow, { footer: Footer, onSend: onSend, messages: state.context.messages, prompt: "What should your app do?", placeholder: "Generate a twilio app that...", active: state.matches('idle') })));
    const offlineContent = (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(Bold_1.Bold, null, "Congratulations on finding the hidden Cheat Mode!"),
        react_2.default.createElement(ink_1.Text, null, "This section of the Developer Mode is only active during certain times during and shortly after the Keynote. Please return during those times. Thank you!")));
    const loadingContent = react_2.default.createElement(LoadingIndicator_1.LoadingIndicator, { text: "Loading Cheat Mode..." });
    let content;
    switch (true) {
        case state.matches('loading'):
            content = loadingContent;
            break;
        case state.matches('off'):
            content = offlineContent;
            break;
        default:
            content = activeContent;
            break;
    }
    return (react_2.default.createElement(Pane_1.Pane, { headline: "Cheat Mode" },
        react_2.default.createElement(PaneContent_1.PaneContent, { breakpoint: breakpoints_1.SHOW_CHEATMODE, fallback: fallbackCheatmode }, content)));
};
