"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClosedCaptioningPane = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useKeynoteInfo_1 = require("../../hooks/useKeynoteInfo");
const useKeynoteTime_1 = require("../../hooks/useKeynoteTime");
const LoadingIndicator_1 = require("../common/LoadingIndicator");
const ActiveKeynoteView_1 = require("../keynote/ActiveKeynoteView");
const InactiveKeynotePane_1 = require("../keynote/InactiveKeynotePane");
const PaneContent_1 = require("./PaneContent");
exports.ClosedCaptioningPane = () => {
    const keynoteInfo = useKeynoteInfo_1.useKeynoteInfo();
    const keynoteTime = useKeynoteTime_1.useKeynoteTime(keynoteInfo);
    const time = keynoteTime && keynoteTime.active && typeof keynoteTime.seconds === 'number'
        ? keynoteTime.seconds * 1000
        : null;
    if (keynoteInfo.status === 'success') {
        if ((keynoteTime === null || keynoteTime === void 0 ? void 0 : keynoteTime.active) && typeof (keynoteTime === null || keynoteTime === void 0 ? void 0 : keynoteTime.seconds) === 'number') {
            return (react_1.default.createElement(ActiveKeynoteView_1.ActiveKeynoteView, { inspectorData: keynoteInfo.data, time: time, vttString: keynoteInfo.vttFileContent }));
        }
        else {
            return (react_1.default.createElement(InactiveKeynotePane_1.InactiveKeynotePane, { keynoteSessionIds: keynoteInfo.data.xray.keynoteSessionIds }));
        }
    }
    else if (keynoteInfo.status === 'error') {
        return (react_1.default.createElement(PaneContent_1.PaneContent, null,
            react_1.default.createElement(ink_1.Text, null, keynoteInfo.error.message)));
    }
    return (react_1.default.createElement(PaneContent_1.PaneContent, null,
        react_1.default.createElement(LoadingIndicator_1.LoadingIndicator, { text: "Loading keynote..." })));
};
