"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainPane = void 0;
const react_1 = __importDefault(require("react"));
const mode_1 = require("../../context/mode");
const CheatModePane_1 = require("./CheatModePane");
const ClosedCaptioningPane_1 = require("./ClosedCaptioningPane");
const DemoPane_1 = require("./DemoPane");
const InstallerPane_1 = require("./InstallerPane");
const ResourcePane_1 = require("./ResourcePane");
const SchedulePane_1 = require("./SchedulePane");
const TestPane_1 = require("./TestPane");
const WelcomePane_1 = require("./WelcomePane");
function MainPane() {
    const { state } = mode_1.useMode();
    switch (true) {
        case state.matches('mainPane.resources'):
            return react_1.default.createElement(ResourcePane_1.ResourcePane, null);
        case state.matches('mainPane.closedCaptioning'):
            return react_1.default.createElement(ClosedCaptioningPane_1.ClosedCaptioningPane, null);
        case state.matches('mainPane.demos'):
            return react_1.default.createElement(DemoPane_1.DemoPane, null);
        case state.matches('mainPane.test'):
            return react_1.default.createElement(TestPane_1.TestPane, null);
        case state.matches('mainPane.schedule'):
            return react_1.default.createElement(SchedulePane_1.SchedulePane, null);
        case state.matches('mainPane.installer'):
            return react_1.default.createElement(InstallerPane_1.InstallerPane, null);
        case state.matches('mainPane.cheatMode'):
            return react_1.default.createElement(CheatModePane_1.CheatModePane, null);
        case state.matches('mainPane.welcome'):
        default:
            return react_1.default.createElement(WelcomePane_1.WelcomePane, null);
    }
}
exports.MainPane = MainPane;
