"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaneContent = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useResize_1 = require("../../hooks/useResize");
const Key_1 = require("../common/Key");
const fallbackTooSmall = (react_1.default.createElement(ink_1.Text, null,
    "Your terminal is too small to support the best experience of Developer Mode. Try hiding the sidebar using ",
    react_1.default.createElement(Key_1.Key, null, "b"),
    " or increase the size of your terminal until this message disappears."));
function PaneContent(_a) {
    var { children, breakpoint = {}, fallback = undefined } = _a, props = __rest(_a, ["children", "breakpoint", "fallback"]);
    const { ref, shouldRender } = useResize_1.useBreakpointForElement(breakpoint);
    return (react_1.default.createElement(ink_1.Box, Object.assign({ ref: ref, flexDirection: "column", flexGrow: 1, paddingLeft: 2, paddingRight: 2 }, props),
        react_1.default.createElement(ink_1.Box, { flexDirection: "column", flexGrow: 1, display: shouldRender ? 'flex' : 'none' }, children),
        !shouldRender ? fallback || fallbackTooSmall : null));
}
exports.PaneContent = PaneContent;
