"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchedulePane = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const useCalendar_1 = require("../../hooks/useCalendar");
const breakpoints_1 = require("../../utils/breakpoints");
const LoadingIndicator_1 = require("../common/LoadingIndicator");
const Pane_1 = require("./Pane");
const PaneContent_1 = require("./PaneContent");
const Schedule_1 = require("./schedule/Schedule");
exports.SchedulePane = () => {
    const { loading, error, data, register, unregister, joinedSessions, } = useCalendar_1.useCalendar();
    return (react_1.default.createElement(Pane_1.Pane, { headline: "SIGNAL 2020" },
        react_1.default.createElement(PaneContent_1.PaneContent, { breakpoint: breakpoints_1.SHOW_SCHEDULE_SECTION },
            loading && react_1.default.createElement(LoadingIndicator_1.LoadingIndicator, { text: "Loading Schedule..." }),
            error && react_1.default.createElement(ink_1.Text, null, error.toString()),
            data && (react_1.default.createElement(Schedule_1.Schedule, { sessions: joinedSessions, calendarSessions: data.getAttendeeCalendar, register: register, unregister: unregister })))));
};
