"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WelcomePane = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const user_1 = require("../../context/user");
const useResize_1 = require("../../hooks/useResize");
const breakpoints_1 = require("../../utils/breakpoints");
const TypeText_1 = require("../animated/TypeText");
const Bold_1 = require("../common/Bold");
const Key_1 = require("../common/Key");
const ListItem_1 = require("../common/ListItem");
const UnorderedList_1 = require("../common/UnorderedList");
const ScrollText_1 = require("../scrollable/ScrollText");
const Pane_1 = require("./Pane");
function FullDescription() {
    return (react_1.default.createElement(ScrollText_1.ScrollText, null,
        react_1.default.createElement(ink_1.Newline, { count: 1 }),
        react_1.default.createElement(ink_1.Text, null, "We are excited that you have decided to join us on this journey."),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "Developer Mode is more than just a gimmick. We acknowledge that this year's SIGNAL is different. We are not gathering in person but instead are gathering virtually from around the world. We are united by one objective:"),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(TypeText_1.TypeText, { text: "// To Build! ", showCursor: "blinking", TextComponent: Bold_1.Bold }),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "We equipped Developer Mode with a variety of functionality:"),
        react_1.default.createElement(ink_1.Newline, null),
        react_1.default.createElement(UnorderedList_1.UnorderedList, null,
            react_1.default.createElement(ListItem_1.ListItem, null, "The full SIGNAL schedule. Including SIGNAL TV programming."),
            react_1.default.createElement(ListItem_1.ListItem, null, "A packed section of demo applications and code samples that you can install within minutes."),
            react_1.default.createElement(ListItem_1.ListItem, null, "An augmented Keynote experience. We'll show you relevant links and demo applications for the things Jeff and others are talking about during the keynote. All topped with some closed-captioning."),
            react_1.default.createElement(ListItem_1.ListItem, null, "A secret cheatmode."),
            react_1.default.createElement(ListItem_1.ListItem, null, "And more")),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null,
            "You can navigate Developer Mode with your keyboard. On the left you can find a collection of special keys to switch modes. Additionally arrow keys, ",
            react_1.default.createElement(Key_1.Key, null, "Tab"),
            ", ",
            react_1.default.createElement(Key_1.Key, null, "Enter"),
            " and ",
            react_1.default.createElement(Key_1.Key, null, "Spacebar"),
            " will be your best friends. And you can always exit by pressing ",
            react_1.default.createElement(Key_1.Key, null, "Ctrl"),
            ' ',
            "and ",
            react_1.default.createElement(Key_1.Key, null, "C"),
            " at the same time."),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "If you want to peek under the hood, have issues or want to contribute, head over to https://github.com/twilio-labs/plugin-signal2020")));
}
function MediumDescription() {
    return (react_1.default.createElement(ScrollText_1.ScrollText, null,
        react_1.default.createElement(ink_1.Newline, { count: 1 }),
        react_1.default.createElement(ink_1.Text, null, "Instead of gathering for SIGNAL in person we are gathering virtually. But we are still united by a shared objective:"),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(TypeText_1.TypeText, { text: "// To Build! ", showCursor: "blinking", TextComponent: Bold_1.Bold }),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "We equipped Developer Mode with a variety of functionality:"),
        react_1.default.createElement(ink_1.Newline, null),
        react_1.default.createElement(UnorderedList_1.UnorderedList, null,
            react_1.default.createElement(ListItem_1.ListItem, null, "The full SIGNAL schedule incl. SIGNAL TV"),
            react_1.default.createElement(ListItem_1.ListItem, null, "A packed demo apps section with automatic download functionality."),
            react_1.default.createElement(ListItem_1.ListItem, null, "An augmented Keynote experience"),
            react_1.default.createElement(ListItem_1.ListItem, null, "A secret cheatmode."),
            react_1.default.createElement(ListItem_1.ListItem, null, "And more")),
        react_1.default.createElement(ink_1.Newline, { count: 1 }),
        react_1.default.createElement(ink_1.Text, null,
            "You can navigate Developer Mode with your keyboard. On the left you can ind a collection of special keys to switch modes. Additionally arrow keys, ",
            react_1.default.createElement(Key_1.Key, null, "Tab"),
            ", ",
            react_1.default.createElement(Key_1.Key, null, "Enter"),
            " and ",
            react_1.default.createElement(Key_1.Key, null, "Spacebar"),
            " will be your best friends. And you can always exit by pressing ",
            react_1.default.createElement(Key_1.Key, null, "Ctrl"),
            ' ',
            "and ",
            react_1.default.createElement(Key_1.Key, null, "C"),
            " at the same time."),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "If you want to peek under the hood, have issues or want to contribute, head over to https://github.com/twilio-labs/plugin-signal2020")));
}
function ShortDescription() {
    return (react_1.default.createElement(ScrollText_1.ScrollText, null,
        react_1.default.createElement(ink_1.Newline, { count: 1 }),
        react_1.default.createElement(ink_1.Text, null, "SIGNAL Developer Mode is an augmentation to your SIGNAL experience, packed with functionality for you to build while you are attending SIGNAL. Incl. a full schedule, useful resources, a packed demo section and a hidden cheat mode."),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null,
            react_1.default.createElement(Bold_1.Bold, null, "Developer Mode will adapt to your terminal window size and works best in bigger windows.")),
        react_1.default.createElement(ink_1.Text, null,
            react_1.default.createElement(ink_1.Newline, null),
            "You can navigate Mode with your keyboard. On the left you can find special keys to switch modes. Arrow keys, ",
            react_1.default.createElement(Key_1.Key, null, "Tab"),
            ",",
            ' ',
            react_1.default.createElement(Key_1.Key, null, "Enter"),
            " and ",
            react_1.default.createElement(Key_1.Key, null, "Spacebar"),
            " can be used to navigate different parts of Developer Mode. You can always exit by pressing",
            ' ',
            react_1.default.createElement(Key_1.Key, null, "Ctrl"),
            " and ",
            react_1.default.createElement(Key_1.Key, null, "C"),
            " at the same time."),
        react_1.default.createElement(ink_1.Newline, { count: 2 }),
        react_1.default.createElement(ink_1.Text, null, "Learn more at https://twil.io/signal-developer-mode.")));
}
function FallbackMessage() {
    return (react_1.default.createElement(ScrollText_1.ScrollText, null,
        react_1.default.createElement(ink_1.Text, null,
            "To learn more about Developer Mode, please increase your terminal size, hide the sidebar using ",
            react_1.default.createElement(Key_1.Key, null, "b"),
            " or visit https://twil.io/signal-developer-mode")));
}
function WelcomePane() {
    const { name } = user_1.useUser();
    const [showMessage, setShowMessage] = react_1.useState(false);
    const makeFullMessageVisible = react_1.useCallback(() => setShowMessage(true), [
        name,
    ]);
    const { shouldRender: [shouldRenderShort, shouldRenderMedium, shouldRenderFull], ref, } = useResize_1.useBreakpointForElement([
        breakpoints_1.SHOW_SHORT_WELCOME_DESCRIPTION,
        breakpoints_1.SHOW_MEDIUM_WELCOME_DESCRIPTION,
        breakpoints_1.SHOW_FULL_WELCOME_DESCRIPTION,
    ], [showMessage]);
    const greetingMessage = react_1.useMemo(() => `Welcome, ${name}. You entered the world of SIGNAL's Developer Mode. `, [name]);
    return (react_1.default.createElement(Pane_1.Pane, { headline: "Ahoy" },
        react_1.default.createElement(ink_1.Box, { flexDirection: "column", paddingLeft: 2, paddingRight: 2, ref: ref, flexGrow: 1, flexShrink: 1 },
            react_1.default.createElement(Bold_1.Bold, null,
                react_1.default.createElement(TypeText_1.TypeText, { text: greetingMessage, onDone: makeFullMessageVisible, showCursor: true })),
            react_1.default.createElement(ink_1.Newline, { count: 1 }),
            showMessage &&
                !shouldRenderShort &&
                !shouldRenderMedium &&
                !shouldRenderFull && react_1.default.createElement(FallbackMessage, null),
            showMessage &&
                shouldRenderShort &&
                !shouldRenderMedium &&
                !shouldRenderFull && react_1.default.createElement(ShortDescription, null),
            showMessage && shouldRenderMedium && !shouldRenderFull && (react_1.default.createElement(MediumDescription, null)),
            showMessage && shouldRenderFull && react_1.default.createElement(FullDescription, null))));
}
exports.WelcomePane = WelcomePane;
