"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleContent = void 0;
const react_1 = __importDefault(require("react"));
const ScrollableItemList_1 = require("../../scrollable/ScrollableItemList");
const SessionEntry_1 = require("./SessionEntry");
function ScheduleContent({ sessions, activeSessionIdx, registeredSessions = new Set(), }) {
    const selectedId = (sessions[activeSessionIdx] || {}).id;
    return (react_1.default.createElement(ScrollableItemList_1.ScrollableItemList, { activeIdx: activeSessionIdx }, sessions.map((s) => (react_1.default.createElement(SessionEntry_1.SessionEntry, { session: s, key: s.id, active: s.id === selectedId, registered: registeredSessions.has(s.id) })))));
}
exports.ScheduleContent = ScheduleContent;
