"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleTab = void 0;
const date_fns_1 = require("date-fns");
const format_1 = __importDefault(require("date-fns/format"));
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const Inverse_1 = require("../../common/Inverse");
function ScheduleTab({ day, active }) {
    const TextComponent = active ? Inverse_1.Inverse : ink_1.Text;
    let title = day;
    if (day.includes('-')) {
        const parsedDate = date_fns_1.parse(day, 'yyyy-MM-dd', new Date());
        title = format_1.default(parsedDate, 'EEE, MMM d');
    }
    return (react_1.default.createElement(ink_1.Box, null,
        react_1.default.createElement(TextComponent, null, title)));
}
exports.ScheduleTab = ScheduleTab;
