"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionDetails = void 0;
const common_tags_1 = require("common-tags");
const figures_1 = __importDefault(require("figures"));
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const scheduleUtils_1 = require("../../../utils/scheduleUtils");
const Bold_1 = require("../../common/Bold");
const Inverse_1 = require("../../common/Inverse");
const Key_1 = require("../../common/Key");
function SessionDetails({ session, registered, updating, }) {
    var _a;
    if (!session) {
        return null;
    }
    const showDescription = !!session.description;
    const formattedDescription = (_a = session.description) === null || _a === void 0 ? void 0 : _a.split('\n').join(' ').split('\r').join('');
    const levels = scheduleUtils_1.getLevels(session);
    return (react_1.default.createElement(ink_1.Box, { padding: 1, flexDirection: "column", borderStyle: "single", flexShrink: 1, flexGrow: 1 },
        react_1.default.createElement(ink_1.Box, null,
            react_1.default.createElement(ink_1.Box, { marginRight: 2 },
                react_1.default.createElement(Bold_1.Bold, { wrap: "truncate-end" },
                    session.title,
                    " ")),
            react_1.default.createElement(ink_1.Spacer, null),
            react_1.default.createElement(ink_1.Box, null, levels.length > 0 && (react_1.default.createElement(Inverse_1.Inverse, { wrap: "truncate-middle" },
                "Level ",
                levels)))),
        react_1.default.createElement(ink_1.Box, null, Array.isArray(session.speakers) && session.speakers.length > 0 && (react_1.default.createElement(ink_1.Text, { wrap: "truncate-end" }, common_tags_1.commaListsAnd `Speakers: ${session.speakers.map((x) => x.name)}`))),
        react_1.default.createElement(ink_1.Box, null, showDescription && (react_1.default.createElement(ink_1.Text, { wrap: "truncate-end" }, formattedDescription))),
        react_1.default.createElement(ink_1.Box, null,
            updating && updating.type && (react_1.default.createElement(ink_1.Text, { color: "yellow" }, updating.type)),
            !updating && registered ? (react_1.default.createElement(ink_1.Text, { color: "green" },
                figures_1.default.tick,
                " registered")) : null),
        react_1.default.createElement(ink_1.Spacer, null),
        react_1.default.createElement(ink_1.Box, { justifyContent: "space-around" },
            session.canRegister && (react_1.default.createElement(ink_1.Text, null,
                "Press ",
                react_1.default.createElement(Key_1.Key, null, "Space"),
                " to ",
                registered ? 'unregister' : 'register',
                ".")),
            react_1.default.createElement(ink_1.Text, null,
                "Press ",
                react_1.default.createElement(Key_1.Key, null, "Enter"),
                " to open session in browser."))));
}
exports.SessionDetails = SessionDetails;
