"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionEntry = void 0;
const figures_1 = __importDefault(require("figures"));
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const ListSelector_1 = require("../../common/ListSelector");
const SessionTime_1 = require("./SessionTime");
const SessionTags_1 = require("./tags/SessionTags");
function SessionEntry({ session, active, registered, }) {
    return (react_1.default.createElement(ink_1.Box, { width: "100%" },
        react_1.default.createElement(ink_1.Box, { flexGrow: 1, flexShrink: 1 },
            react_1.default.createElement(ink_1.Box, { flexShrink: 0 },
                react_1.default.createElement(ink_1.Text, null,
                    react_1.default.createElement(ListSelector_1.ListSelector, { active: active }),
                    react_1.default.createElement(SessionTime_1.SessionTime, { session: session }),
                    registered && react_1.default.createElement(ink_1.Text, { color: "green" },
                        figures_1.default.tick,
                        " "))),
            react_1.default.createElement(ink_1.Box, { flexGrow: 1 },
                react_1.default.createElement(ink_1.Text, { wrap: "truncate-end" }, session.title)),
            react_1.default.createElement(ink_1.Box, { marginLeft: 2, flexShrink: 0 },
                react_1.default.createElement(SessionTags_1.SessionTags, { session: session })))));
}
exports.SessionEntry = SessionEntry;
