"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionTime = void 0;
const format_1 = __importDefault(require("date-fns/format"));
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const scheduleUtils_1 = require("../../../utils/scheduleUtils");
function SessionTime({ session }) {
    const isLive = scheduleUtils_1.hasLiveTag(session);
    const signalTv = scheduleUtils_1.isSignalTv(session);
    if (!isLive && !signalTv) {
        return null;
    }
    const startTime = format_1.default(new Date(session.start_date), 'HH:mm');
    const endTime = format_1.default(new Date(session.end_date), 'HH:mm');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        startTime,
        " ",
        react_1.default.createElement(ink_1.Text, { dimColor: true },
            "- ",
            endTime),
        ' │ '));
}
exports.SessionTime = SessionTime;
