"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionTags = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const scheduleUtils_1 = require("../../../../utils/scheduleUtils");
const LiveOrOnDemandTag_1 = require("./LiveOrOnDemandTag");
const PaidTag_1 = require("./PaidTag");
const SignalTvTag_1 = require("./SignalTvTag");
function SessionTags({ session }) {
    const live = scheduleUtils_1.isLive(session);
    const paid = scheduleUtils_1.isPaid(session);
    const signalTv = scheduleUtils_1.isSignalTv(session);
    return (react_1.default.createElement(ink_1.Text, null,
        paid && react_1.default.createElement(PaidTag_1.PaidTag, null),
        !signalTv && react_1.default.createElement(LiveOrOnDemandTag_1.LiveOrOnDemandTag, { live: live }),
        signalTv && react_1.default.createElement(SignalTvTag_1.SignalTvTag, null)));
}
exports.SessionTags = SessionTags;
