"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollableItemList = void 0;
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const useResize_1 = require("../../hooks/useResize");
const EmptyRow_1 = require("./EmptyRow");
const MoreItemsDown_1 = require("./MoreItemsDown");
const MoreItemsUp_1 = require("./MoreItemsUp");
function ScrollableItemList(_a) {
    var { activeIdx, children, showScrollIndicator = true, rowsPerLine = 1, moreAboveText, moreBelowText } = _a, props = __rest(_a, ["activeIdx", "children", "showScrollIndicator", "rowsPerLine", "moreAboveText", "moreBelowText"]);
    const { ref, height } = useResize_1.useResponsiveMeasureElement([children]);
    const [slicedEntries, offset] = react_1.useMemo(() => {
        const entries = react_1.default.Children.toArray(children);
        const availableRows = height;
        const allNeededRows = entries.length * rowsPerLine;
        let numberOfRowsShown;
        if (availableRows < allNeededRows) {
            if (availableRows === 0) {
                numberOfRowsShown = rowsPerLine;
            }
            else {
                numberOfRowsShown = availableRows;
            }
        }
        else {
            numberOfRowsShown = allNeededRows;
        }
        const activeIdxPerLine = activeIdx * rowsPerLine;
        let offset = 0;
        if (activeIdxPerLine > (numberOfRowsShown + offset) / 2 &&
            numberOfRowsShown !== allNeededRows) {
            offset = Math.round((activeIdxPerLine - Math.floor((numberOfRowsShown + offset) / 2)) /
                rowsPerLine);
        }
        const numberOfItems = Math.floor(numberOfRowsShown / rowsPerLine);
        const slicedEntries = entries.slice(offset, offset + numberOfItems);
        return [slicedEntries, offset, numberOfItems];
    }, [children, activeIdx, height]);
    const shouldRenderMoreEntriesBelow = showScrollIndicator && slicedEntries.length * rowsPerLine >= height;
    const shouldRenderMoreEntriesAbove = showScrollIndicator && offset > 0;
    return (react_1.default.createElement(ink_1.Box, Object.assign({ flexGrow: 1, flexShrink: 1, padding: 0, paddingTop: 0, paddingBottom: 0, borderStyle: "single", flexDirection: "column" }, props),
        shouldRenderMoreEntriesAbove ? (react_1.default.createElement(MoreItemsUp_1.MoreItemsUp, { text: moreAboveText })) : !showScrollIndicator ? null : (react_1.default.createElement(EmptyRow_1.EmptyRow, null)),
        react_1.default.createElement(ink_1.Box, { ref: ref, flexGrow: 1, flexDirection: "column" }, slicedEntries),
        shouldRenderMoreEntriesBelow ? (react_1.default.createElement(MoreItemsDown_1.MoreItemsDown, { text: moreBelowText })) : !showScrollIndicator ? null : (react_1.default.createElement(EmptyRow_1.EmptyRow, null))));
}
exports.ScrollableItemList = ScrollableItemList;
