"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controls = void 0;
const ink_1 = require("ink");
const react_1 = __importDefault(require("react"));
const Divider_1 = require("../common/Divider");
const Key_1 = require("../common/Key");
function Controls() {
    const keys = [
        { key: 'b', description: 'Toggle Sidebar' },
        { key: 'w', description: 'Welcome' },
        { key: 'k', description: 'Keynote' },
        { key: 's', description: 'Schedule' },
        { key: 'd', description: 'Demos' },
        { key: 'r', description: 'Useful Resources ' },
        { key: 'q', description: 'Exit' },
    ];
    return (react_1.default.createElement(ink_1.Box, { flexDirection: "column", padding: 1, flexShrink: 0 },
        react_1.default.createElement(Divider_1.Divider, { title: 'Controls' }),
        react_1.default.createElement(ink_1.Text, null, "Press any of the keys to switch"),
        keys.map((item) => (react_1.default.createElement(ink_1.Text, { key: item.key },
            react_1.default.createElement(Key_1.Key, null, item.key),
            " for ",
            item.description)))));
}
exports.Controls = Controls;
