"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sidebar = void 0;
const format_1 = __importDefault(require("date-fns/format"));
const ink_1 = require("ink");
const ms_1 = __importDefault(require("ms"));
const react_1 = __importStar(require("react"));
const mode_1 = require("../../context/mode");
const user_1 = require("../../context/user");
const useResize_1 = require("../../hooks/useResize");
const Bold_1 = require("../common/Bold");
const Avatar_1 = require("../graphics/Avatar");
const MissingAvatar_1 = require("../graphics/MissingAvatar");
const Controls_1 = require("./Controls");
const NextUpSection_1 = require("./NextUpSection");
function Sidebar() {
    const { width: totalWidth, height: totalHeight } = useResize_1.useResponsiveWindowSize();
    const { name, heroImage } = user_1.useUser();
    const { state } = mode_1.useMode();
    const [currentTime, setCurrentTime] = react_1.useState(new Date());
    react_1.useEffect(() => {
        const intervalId = setInterval(() => {
            setCurrentTime(new Date());
        }, ms_1.default('1m'));
        return () => {
            if (intervalId) {
                clearInterval(intervalId);
            }
        };
    }, []);
    if (state.matches('sideBar.hidden')) {
        return null;
    }
    return (react_1.default.createElement(ink_1.Box, { width: 40, borderStyle: "single", flexDirection: "column" },
        react_1.default.createElement(ink_1.Box, { padding: 1, flexDirection: "column", height: 5, minHeight: 5, flexShrink: 0 },
            react_1.default.createElement(Bold_1.Bold, null,
                "Welcome to SIGNAL 2020, ",
                name,
                "!"),
            react_1.default.createElement(ink_1.Text, null,
                "Current Time: ",
                format_1.default(currentTime, 'HH:mm')),
            process.env.DEBUG_SIGNAL && (react_1.default.createElement(Bold_1.Bold, null,
                "w: ",
                totalWidth,
                " h: ",
                totalHeight))),
        heroImage ? (react_1.default.createElement(Avatar_1.Avatar, { imageBuffer: heroImage })) : heroImage === null ? (react_1.default.createElement(MissingAvatar_1.MissingAvatar, null)) : (react_1.default.createElement(ink_1.Box, { height: 17 })),
        react_1.default.createElement(NextUpSection_1.NextUpSection, null),
        react_1.default.createElement(Controls_1.Controls, null)));
}
exports.Sidebar = Sidebar;
