"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModeProvider = exports.useMode = void 0;
const react_1 = require("@xstate/react");
const react_2 = __importDefault(require("react"));
const useLogValueChange_1 = require("../hooks/useLogValueChange");
const modeMachine_1 = require("../machines/modeMachine");
const ModeContext = react_2.default.createContext({});
exports.useMode = () => react_2.default.useContext(ModeContext);
exports.ModeProvider = ({ children }) => {
    const [state, dispatch] = react_1.useMachine(modeMachine_1.modeMachine);
    useLogValueChange_1.useLogValueChange('mode', state.value);
    return (react_2.default.createElement(ModeContext.Provider, { value: { state, dispatch } }, children));
};
