"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserProvider = exports.useUser = void 0;
const client_1 = require("@apollo/client");
const ms_1 = __importDefault(require("ms"));
const react_1 = __importStar(require("react"));
const login_1 = require("../api/login");
const useTerminalInfo_1 = require("../hooks/useTerminalInfo");
const user_1 = require("../queries/user");
const graphqlClient_1 = require("../utils/graphqlClient");
const urlToBuffer_1 = require("../utils/urlToBuffer");
const defaultUser = {
    id: '',
    name: 'Operator',
    accountSid: 'ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa',
    twilioUsername: null,
    twilioPassword: null,
    heroImage: undefined,
    refreshToken: undefined,
    region: 'Americas',
    syncToken: undefined,
};
const UserContext = react_1.default.createContext(defaultUser);
exports.useUser = () => react_1.default.useContext(UserContext);
exports.UserProvider = ({ defaultValue, children, }) => {
    const [value, setValue] = react_1.useState(Object.assign(Object.assign({}, defaultUser), defaultValue));
    const { data } = client_1.useQuery(user_1.UserProfileQuery);
    const { isGitBash } = useTerminalInfo_1.useTerminalInfo();
    const noColors = process.env.FORCE_COLOR === '0';
    react_1.useEffect(() => {
        (() => __awaiter(void 0, void 0, void 0, function* () {
            if (data && data.getProfile) {
                const heroImage = isGitBash
                    ? undefined
                    : noColors
                        ? null
                        : yield urlToBuffer_1.urlToBuffer(data.getProfile.hero_url);
                setValue((currentValue) => {
                    return Object.assign(Object.assign({}, currentValue), { id: data.getProfile.id, name: data.getProfile.first_name, heroImage: heroImage, region: data.getProfile.region, syncToken: data.getProfile.sync_token || undefined, profile: Object.assign({}, data.getProfile) });
                });
            }
        }))();
    }, [data]);
    react_1.useEffect(() => {
        const timeoutId = setTimeout(() => __awaiter(void 0, void 0, void 0, function* () {
            if (value.refreshToken) {
                const newAuthToken = yield login_1.refreshToken(value.refreshToken);
                graphqlClient_1.setAuthToken(newAuthToken);
            }
        }), ms_1.default('12h'));
        return () => {
            if (timeoutId) {
                clearTimeout(timeoutId);
            }
        };
    });
    return react_1.default.createElement(UserContext.Provider, { value: value }, children);
};
