"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAnimation = void 0;
const is_ci_1 = __importDefault(require("is-ci"));
const useResize_1 = require("./useResize");
const useTerminalInfo_1 = require("./useTerminalInfo");
function useAnimation() {
    const termInfo = useTerminalInfo_1.useTerminalInfo();
    const { height } = useResize_1.useResponsiveWindowSize();
    let shouldAnimate = true;
    if (process.env.NODE_ENV === 'test') {
        shouldAnimate = false;
    }
    else if (is_ci_1.default) {
        shouldAnimate = false;
    }
    else if (termInfo.isITerm || termInfo.isGitBash) {
        shouldAnimate = false;
    }
    else if (termInfo.isWindows && (height || 0) > 40) {
        shouldAnimate = false;
    }
    else if (termInfo.terminalName === 'Windows Terminal') {
        shouldAnimate = false;
    }
    if (process.env.FORCE_ANIMATION === '1') {
        shouldAnimate = true;
    }
    else if (process.env.FORCE_ANIMATION === '0') {
        shouldAnimate = false;
    }
    return { shouldAnimate };
}
exports.useAnimation = useAnimation;
