"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCounter = void 0;
const react_1 = require("react");
function useCounter(increments = 1000, interval = 1000) {
    const [count, setCount] = react_1.useState(0);
    react_1.useEffect(() => {
        const intervalId = setInterval(() => {
            setCount((c) => c + increments);
        }, interval);
        return () => {
            if (intervalId) {
                clearInterval(intervalId);
            }
        };
    }, []);
    return count;
}
exports.useCounter = useCounter;
