"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useImage = void 0;
const react_1 = require("react");
const terminal_image_1 = __importDefault(require("terminal-image"));
function cropImageString(imageString) {
    return imageString
        .split('\n')
        .filter((line) => line.trim().length !== 0)
        .join('\n');
}
function useImage(imageBuffer, width) {
    const [imageString, setImageString] = react_1.useState(null);
    react_1.useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            const backup = process.env.TERM_PROGRAM;
            process.env.TERM_PROGRAM = 'INVALID';
            if (width <= 0 || imageBuffer === null) {
                return;
            }
            const newImageString = yield terminal_image_1.default.buffer(imageBuffer, {
                width,
            });
            process.env.TERM_PROGRAM = backup;
            setImageString(cropImageString(newImageString));
        }))();
    }, [imageBuffer, width]);
    return imageString;
}
exports.useImage = useImage;
