"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useKeynoteTime = void 0;
const user_1 = require("../context/user");
const logger_1 = __importDefault(require("../utils/logger"));
const useSyncClient_1 = require("./useSyncClient");
const logger = logger_1.default.child({ module: 'useKeynoteTime' });
function useKeynoteTime(keynoteInfo) {
    var _a;
    const user = user_1.useUser();
    const sessionIdx = user.region === 'APJ' ? 1 : user.region === 'EMEA' ? 2 : 0;
    const sessionId = (_a = keynoteInfo.data) === null || _a === void 0 ? void 0 : _a.xray.keynoteSessionIds[sessionIdx];
    const documentId = sessionId ? `${sessionId}.${user.id}` : undefined;
    const { value, error } = useSyncClient_1.useSyncDocument(documentId, user.syncToken);
    if (error) {
        logger.error(error);
    }
    return value;
}
exports.useKeynoteTime = useKeynoteTime;
