"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useScrollableList = void 0;
const ink_1 = require("ink");
const react_1 = require("react");
const arrayHelpers_1 = require("../utils/arrayHelpers");
function useScrollableList(initialIdx, list, active = true) {
    const [currentIdx, setCurrentIdx] = react_1.useState(initialIdx);
    ink_1.useInput((input, key) => {
        if (key.upArrow) {
            setCurrentIdx((idx) => arrayHelpers_1.prevIdxWithoutRollover(idx));
        }
        else if (key.downArrow) {
            setCurrentIdx((idx) => arrayHelpers_1.nextIdxWithoutRollover(idx, list));
        }
    }, {
        isActive: active,
    });
    return [currentIdx, setCurrentIdx];
}
exports.useScrollableList = useScrollableList;
