"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSignalTv = void 0;
const react_1 = require("react");
const config_1 = __importDefault(require("../utils/config"));
const useApi_1 = require("./useApi");
function extractNormalizedSchedule(data) {
    if (typeof data == 'undefined') {
        return undefined;
    }
    return data.map((entry) => {
        let speakers = entry.talent
            .split(',')
            .map((name) => ({ name: name.trim() }));
        if (speakers.length === 1 && speakers[0].name.length === 0) {
            speakers = [];
        }
        return {
            id: entry.id,
            start_date: entry.start * 1000,
            end_date: entry.end * 1000,
            tags: entry.tags,
            title: entry.title,
            description: entry.description,
            speakers,
            url: 'https://twitch.tv/twilio',
            signalTv: true,
        };
    });
}
function useSignalTv() {
    const apiResponse = useApi_1.useGot(config_1.default.signalTvSchedule);
    const signalTvSchedule = react_1.useMemo(() => extractNormalizedSchedule(apiResponse === null || apiResponse === void 0 ? void 0 : apiResponse.data), [apiResponse.data]);
    return Object.assign(Object.assign({}, apiResponse), { signalTvSchedule });
}
exports.useSignalTv = useSignalTv;
