"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useVersionCheck = void 0;
const got_1 = __importDefault(require("got"));
const react_1 = require("react");
const gt_1 = __importDefault(require("semver/functions/gt"));
/* eslint-disable @typescript-eslint/no-var-requires */
/// @ts-ignore
const pkgJson = require('../../package.json');
function fetchLatestVersion() {
    return __awaiter(this, void 0, void 0, function* () {
        const resp = got_1.default('https://unpkg.com/@twilio-labs/plugin-signal2020/package.json');
        const { version } = yield resp.json();
        return version;
    });
}
function useVersionCheck() {
    const [latestVersion, setLatestVersion] = react_1.useState(undefined);
    react_1.useEffect(() => {
        fetchLatestVersion().then(setLatestVersion);
    }, []);
    const updateAvailable = latestVersion
        ? gt_1.default(latestVersion, pkgJson.version)
        : null;
    return {
        current: pkgJson.version,
        latest: latestVersion,
        updateAvailable: updateAvailable,
    };
}
exports.useVersionCheck = useVersionCheck;
