"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useVtt = void 0;
const node_webvtt_1 = __importDefault(require("node-webvtt"));
const react_1 = require("react");
function useVtt(vttString) {
    const [vtt, setVtt] = react_1.useState({ cues: [] });
    react_1.useEffect(() => {
        const parsed = node_webvtt_1.default.parse(vttString);
        parsed.cues = parsed.cues.map((c) => {
            return Object.assign(Object.assign({}, c), { start: c.start * 1000, end: c.end * 1000 });
        });
        setVtt(parsed);
    }, [vttString]);
    return vtt;
}
exports.useVtt = useVtt;
