"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cheatModeMachine = exports.CheatModeEvents = void 0;
const xstate_1 = require("xstate");
var CheatModeEvents;
(function (CheatModeEvents) {
    CheatModeEvents["ACTIVATE"] = "ACTIVATE";
    CheatModeEvents["DEACTIVATE"] = "DEACTIVATE";
    CheatModeEvents["REQUEST"] = "REQUEST";
    CheatModeEvents["DEPLOY"] = "DEPLOY";
    CheatModeEvents["UPDATE"] = "UPDATE";
})(CheatModeEvents = exports.CheatModeEvents || (exports.CheatModeEvents = {}));
// eslint-disable-next-line new-cap
exports.cheatModeMachine = xstate_1.Machine({
    id: 'cheatMode',
    initial: 'loading',
    context: {
        latestDeploymentInfo: undefined,
        currentRequest: undefined,
        latestTwiml: undefined,
        messages: [],
        errors: [],
        username: undefined,
        password: undefined,
    },
    states: {
        loading: {
            on: {
                DEACTIVATE: 'off',
                ACTIVATE: 'idle',
            },
        },
        off: {
            on: {
                ACTIVATE: 'idle',
            },
        },
        idle: {
            on: {
                REQUEST: {
                    target: 'requesting',
                    actions: ['addRequestMessage'],
                },
                DEPLOY: {
                    cond: 'canDeploy',
                    target: 'deploying',
                },
            },
        },
        requesting: {
            invoke: {
                id: 'fetchingResult',
                src: 'fetchResult',
                onDone: {
                    target: 'idle',
                    actions: ['addTwimlResult'],
                },
                onError: {
                    target: 'idle',
                    actions: ['addErrorMessage'],
                },
            },
        },
        deploying: {
            invoke: {
                id: 'deployingResult',
                src: 'deployResult',
                onDone: {
                    target: 'idle',
                    actions: ['addDeployResult'],
                },
                onError: {
                    target: 'idle',
                    actions: ['addErrorMessage'],
                },
            },
            on: {
                UPDATE: {
                    actions: ['handleUpdateMessage'],
                },
            },
        },
    },
});
