"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnregisterForSessionQuery = exports.RegisterForSessionQuery = exports.SessionsQuery = void 0;
const client_1 = require("@apollo/client");
exports.SessionsQuery = client_1.gql `
  # Write your query or mutation here
  query GetSessions {
    getPublicSessions {
      id
      start_date
      end_date
      title
      description
      speakers {
        name
      }
      tags {
        name
      }
    }
    getAttendeeCalendar {
      id
      start_date
      end_date
      title
      description
      speakers {
        name
      }
      tags {
        name
      }
    }
  }
`;
exports.RegisterForSessionQuery = client_1.gql `
  mutation registerToSession($sessionId: String!) {
    registerToSession(sessionId: $sessionId)
  }
`;
exports.UnregisterForSessionQuery = client_1.gql `
  mutation unregisterFromSession($sessionId: String!) {
    unregisterFromSession(sessionId: $sessionId)
  }
`;
