"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cheatModeApiQuery = void 0;
const got_1 = __importDefault(require("got"));
const twilio_sync_1 = __importDefault(require("twilio-sync"));
const config_1 = require("./config");
const diagnostics_1 = require("./diagnostics");
function cheatModeApiQuery(query, config = {}) {
    /* eslint-disable no-async-promise-executor */
    return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
        let counter = 0;
        const properties = Object.assign({ ModerateQuery: true, PostToGitHub: false, hostName: new URL(config_1.cheatModeApi).hostname, onStatusChange: undefined }, config);
        const response = got_1.default(`${config_1.cheatModeApi}/requester?Query=${encodeURIComponent(query)}&Config=${encodeURIComponent(JSON.stringify(properties))}`, {
            headers: {
                'user-agent': diagnostics_1.getUserAgent(),
            },
        });
        response.json().then((json) => {
            try {
                const syncClient = new twilio_sync_1.default(json.token);
                syncClient.document(json.id).then((doc) => {
                    function nextStep() {
                        return __awaiter(this, void 0, void 0, function* () {
                            try {
                                const step = yield got_1.default(`${config_1.cheatModeApi}/requester?Id=${json.id}&counter=${++counter}`, {
                                    headers: {
                                        'user-agent': diagnostics_1.getUserAgent(),
                                    },
                                });
                                if (step.statusCode !== 200) {
                                    this.logger.debug('Got error "%s". Trying again.', step.statusMessage);
                                    this.logger.debug('Current counter %d', counter);
                                    if (counter > 15) {
                                        throw new Error('Maximum retries reached');
                                    }
                                    // Recurse, what could go wrong?
                                    nextStep();
                                }
                                else {
                                    const stepJson = JSON.parse(step.body);
                                    if (stepJson.status === 'error') {
                                        return reject(new Error(stepJson.errorMessage));
                                    }
                                }
                            }
                            catch (err) {
                                return reject(err);
                            }
                        });
                    }
                    doc.on('updated', (data) => {
                        if (data.value.status === 'complete') {
                            return resolve(data.value);
                        }
                        else {
                            if (properties.onStatusChange) {
                                properties.onStatusChange(data.value.status);
                            }
                            nextStep();
                        }
                    });
                    // Kick things off
                    nextStep();
                });
            }
            catch (err) {
                return reject(err);
            }
        });
    }));
}
exports.cheatModeApiQuery = cheatModeApiQuery;
