"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.timeToText = exports.sortByDate = void 0;
const ms_1 = __importDefault(require("ms"));
function sortByDate(a, b) {
    const timeSorted = a.start_date - b.start_date;
    if (timeSorted === 0) {
        return a.title.localeCompare(b.title);
    }
    return timeSorted;
}
exports.sortByDate = sortByDate;
function timeToText(time) {
    let rest = time;
    const hours = Math.floor(rest / ms_1.default('1h'));
    rest = rest % ms_1.default('1h');
    const minutes = Math.floor(rest / ms_1.default('1m'));
    rest = rest % ms_1.default('1m');
    const seconds = Math.floor(rest / 1000);
    return `${hours}:${minutes > 9 ? '' : '0'}${minutes}:${seconds > 9 ? '' : '0'}${seconds}`;
}
exports.timeToText = timeToText;
