"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.client = exports.setAuthToken = void 0;
const client_1 = require("@apollo/client");
const context_1 = require("@apollo/client/link/context");
const cross_fetch_1 = __importDefault(require("cross-fetch"));
const config_1 = __importDefault(require("./config"));
let _authToken;
function setAuthToken(token = '') {
    _authToken = token;
    const httpLink = new client_1.HttpLink({
        fetch: cross_fetch_1.default,
        uri: `${config_1.default.signalApi}/`,
    });
    const authLink = context_1.setContext((_, { headers }) => {
        // get the authentication token from local storage if it exists
        const token = _authToken;
        // return the headers to the context so httpLink can read them
        return {
            headers: Object.assign(Object.assign({}, headers), { authorization: token ? `${token}` : '' }),
        };
    });
    _client = new client_1.ApolloClient({
        link: authLink.concat(httpLink),
        cache: new client_1.InMemoryCache({
            typePolicies: {
                Query: {
                    fields: {
                        getAttendeeCalendar: {
                            merge(existing, incoming) {
                                // always take the database as source of truth
                                return [...incoming];
                            },
                        },
                    },
                },
            },
        }),
    });
}
exports.setAuthToken = setAuthToken;
let _client;
// creating a default client;
setAuthToken();
function client() {
    return _client;
}
exports.client = client;
