"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.openSessionUrl = exports.openBrowserUrl = exports.addUtmParameters = void 0;
const open_1 = __importDefault(require("open"));
const config_1 = __importDefault(require("./config"));
function addUtmParameters(url) {
    const parsedUrl = new URL(url);
    parsedUrl.searchParams.append('utm_source', 'Twilio');
    parsedUrl.searchParams.append('utm_medium', 'Terminal');
    parsedUrl.searchParams.append('utm_campaign', 'signal_developer_mode');
    return parsedUrl.toString();
}
exports.addUtmParameters = addUtmParameters;
function openBrowserUrl(url, addParameters = true) {
    if (addParameters) {
        url = addUtmParameters(url);
    }
    return open_1.default(url);
}
exports.openBrowserUrl = openBrowserUrl;
function openSessionUrl(sessionId) {
    return openBrowserUrl(`${config_1.default.signalWebsite}/sessions/${sessionId}`);
}
exports.openSessionUrl = openSessionUrl;
